/*************************************************************************/
/* module:          Communication Services, standard type definitions    */
/* file:            src/xpt/all/xpttypes.h                               */
/* target system:   all                                                  */
/* target OS:       all                                                  */
/*************************************************************************/

/*
 * Copyright Notice
 * Copyright (c) Ericsson, IBM, Lotus, Matsushita Communication 
 * Industrial Co., Ltd., Motorola, Nokia, Openwave Systems, Inc., 
 * Palm, Inc., Psion, Starfish Software, Symbian, Ltd. (2001).
 * All Rights Reserved.
 * Implementation of all or part of any Specification may require 
 * licenses under third party intellectual property rights, 
 * including without limitation, patent rights (such a third party 
 * may or may not be a Supporter). The Sponsors of the Specification 
 * are not responsible and shall not be held responsible in any 
 * manner for identifying or failing to identify any or all such 
 * third party intellectual property rights.
 * 
 * THIS DOCUMENT AND THE INFORMATION CONTAINED HEREIN ARE PROVIDED 
 * ON AN "AS IS" BASIS WITHOUT WARRANTY OF ANY KIND AND ERICSSON, IBM, 
 * LOTUS, MATSUSHITA COMMUNICATION INDUSTRIAL CO. LTD, MOTOROLA, 
 * NOKIA, PALM INC., PSION, STARFISH SOFTWARE AND ALL OTHER SYNCML 
 * SPONSORS DISCLAIM ALL WARRANTIES, EXPRESS OR IMPLIED, INCLUDING 
 * BUT NOT LIMITED TO ANY WARRANTY THAT THE USE OF THE INFORMATION 
 * HEREIN WILL NOT INFRINGE ANY RIGHTS OR ANY IMPLIED WARRANTIES OF 
 * MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO EVENT 
 * SHALL ERICSSON, IBM, LOTUS, MATSUSHITA COMMUNICATION INDUSTRIAL CO., 
 * LTD, MOTOROLA, NOKIA, PALM INC., PSION, STARFISH SOFTWARE OR ANY 
 * OTHER SYNCML SPONSOR BE LIABLE TO ANY PARTY FOR ANY LOSS OF 
 * PROFITS, LOSS OF BUSINESS, LOSS OF USE OF DATA, INTERRUPTION OF 
 * BUSINESS, OR FOR DIRECT, INDIRECT, SPECIAL OR EXEMPLARY, INCIDENTAL, 
 * PUNITIVE OR CONSEQUENTIAL DAMAGES OF ANY KIND IN CONNECTION WITH 
 * THIS DOCUMENT OR THE INFORMATION CONTAINED HEREIN, EVEN IF ADVISED 
 * OF THE POSSIBILITY OF SUCH LOSS OR DAMAGE.
 * 
 * The above notice and this paragraph must be included on all copies 
 * of this document that are made.
 * 
 */


/**
 * Definition of several basic datatypes.
 *
 */

#ifndef XPTTYPES_H
#define XPTTYPES_H

#ifdef __cplusplus
extern "C" {
#endif


#ifndef Bool_t
  #if defined(__INIT_SML_XPT_GLOBALS) || defined(__cplusplus)
     typedef bool Bool_t;
  #else
     #if defined(_WIN32) || defined(linux) || defined(__GCC32__)
        // for C compilers without C99 extensions
        typedef enum { false = 0,
               true = 1 }  Bool_t;
     #else
        typedef int Bool_t;
    #endif
  #endif
#endif

typedef unsigned char *DataBuffer_t;
typedef DataBuffer_t  *DataPtr_t;
typedef unsigned long  BufferSize_t;
typedef BufferSize_t  *BufferSizePtr_t;

typedef const char      *CString_t;
typedef char            *Ptr_t;
typedef char            *StringBuffer_t;
typedef CString_t       *StringPtr_t;
typedef StringBuffer_t  *StringBufferPtr_t;
typedef unsigned short   StringLength_t;



#ifdef __cplusplus
}
#endif

#endif
